%% Examples

%% LTI model identification
% * <../../examples/html/ex01_lti_four.html Example 1:> Fourth-order LTI model with coloured process noise in closed loop
% * <../../examples/html/ex02_lti_four_fir.html Example 2:> Fourth-order
% LTI model without process noise in closed loop
% * <../../examples/html/ex03_lti_duct.html Example 3:> High-order LTI
% model of acoustical duct 
% * <../../examples/html/ex04_lti_wts.html Example 4:> LTI model of a
% Coleman tranformed wind turbine system 
% * <../../examples/html/ex05_lti_wts_batch.html Example 5:> LTI model of a
% Coleman tranformed wind turbine system with batches of data 
% * <../../examples/html/ex06_lti_four_unc.html Example 6:> Uncertainty bounds on estimation using first-order variance for PBSIDopt 
% * <../../examples/html/ex07_lti_wts_mcs.html Example 7:> Uncertainty bounds on estimation using Monte-Carlo simulations 
% * <../../examples/html/ex08_lti_wts_bootstrap.html Example 8:> Uncertainty bounds on estimation using Bootstrap simulations
% * <../../examples/html/ex09_lti_plus_periodic_rotor.html Example 9:> PBSIDopt identification of Smart Rotor with periodic effects

%% Recursive-LTI model identification
% * <../../examples/html/ex10_rlti_fast.html Example 10:> Fast-varying
% Recursive LTI
% model in open loop
% * <../../examples/html/ex11_rlti_slow.html Example 11:> Slow-varying Recursive LTI
% model in open loop
% * <../../examples/html/ex12_rlti_fast_closed.html Example 12:> Fast-varying Recursive LTI
% model in closed loop
% * <../../examples/html/ex13_rlti_slow_closed.html Example 13:> Slow-varying Recursive LTI
% model in closed loop


%% Hammerstein/Wiener model identification
% * <../../examples/html/ex14_hamm_four.html Example 14:> Fourth-order
% Hammerstein model 
% * <../../examples/html/ex15_wiener_four.html Example 15:> Fourth-order
% Wiener model 
% * <../../examples/html/ex16_hammwiener_four.html Example 16:> Fourth-order
% Hammerstein-Wiener model 

%% LPV model discretization
% * <../../examples/html/ex17_c2d_f16.html Example 17:> Discretization of
% continuous LPV model of F-16 
% * <../../examples/html/ex18_c2d_flutter.html Example 18:> Discretization
% of continuous LPV model of wing flutter 

%% LPV model identification
% * <../../examples/html/ex19_lpv_flap.html Example 19:> Second-order LPV
% model of flapping dynamics
% * <../../examples/html/ex19b_lpv_stable_predictor.html Example 19b:> Stabilizing the predictor form of the LPV model of the flapping dynamics
% * <../../examples/html/ex19c_lpv_sparse.html Example 19c:> Using sparse estimation in the identification of a second-order LPV model
% * <../../examples/html/ex20_lpv_mimo.html Example 20:> Fourth-order MIMO LPV model 

%% Periodic-LPV model identification
% * <../../examples/html/ex21_plpv_flap.html Example 21:> Second-order
% Periodic-LPV model of flapping dynamics 
% * <../../examples/html/ex22_plpv_mimo.html Example 22:> Third-order SIMO
% Periodic-LPV model 
% * <../../examples/html/ex23_plpv_wts.html Example 23:> Periodic-LPV model
% of a wind turbine system 

