%% Functions -- Alphabetical List
%   abc2idss        - Create IDSS model structure.
%   abcd2idss       - Create IDSS model structure.
%   abcdk2idss      - Create IDSS model structure.
%   abck2idss       - Create IDSS model structure.
%   dbode           - Bode diagram
%   dbodemag        - Bode diagram (magnitude only).
%   dbodemagpatch   - Bode diagram with given error bounds (magnitude only).
%   dbodemagsd      - Bode diagram with probalistic error bounds (magnitude only).
%   dbodepatch      - Bode diagram with given error bounds.
%   dbodesd         - Bode diagram with probalistic error bounds.
%   deigen          - Eigenvalues plot.
%   deigensd        - Eigenvalues plot with probalistic error bounds.
%   dmodx           - Closed-loop LTI system identification using the PBSIDopt method.
%   dnyquist        - Nyquist diagram.
%   dnyquistdet     - Nyquist diagram (det(G)).
%   dnyquistdetsd   - Nyquist diagram with probalistic error bounds (det(G)).
%   dnyquistsd      - Nyquist diagram with probalistic error bounds.
%   dordfir         - Open-loop LTI system identification using the PBSIDopt method.
%   dordvarmax      - Closed-loop LTI system identification using the PBSIDopt method.
%   dordvarx        - Closed-loop LTI system identification using the PBSIDopt method.
%   dvar2eig        - Eigenvalues and its covariance estimation.
%   dvar2frd        - System and its covariance estimation in frequency domain.
%   dvar4abcdk      - Asymptotic variance of the PBSIDopt (VARX only) estimation.
%   dvar4abck       - Asymptotic variance of the PBSIDopt (VARX only) estimation.
%   dvar4varx       - Asymptotic variance of the VARX estimation.
%   dx2abc          - Estimates the matrices A, B, and C of the state space model.
%   dx2abcd         - Estimates the matrices A, B, C, and D of the state space model.
%   dx2abcdk        - Estimates the matrices A, B, C, D, and K of the state space model.
%   dx2abck         - Estimates the matrices A, B, C, and K of the state space model.
%   fit             - Model fit [%].
%   hmodx           - Closed-loop Hammerstein system identification using the PBSIDopt method.
%   hordvarx        - Closed-loop Hammerstein system identification using the PBSIDopt method.
%   hwmodx          - Closed-loop Hammerstein-Wiener system identification using the PBSIDopt method.
%   hwordvarx       - Closed-loop Hammerstein-Wiener system identification using the PBSIDopt method.
%   hwx2abcdk       - Estimates the matrices A, B, C, D, and K of the state space model.
%   hwx2abck        - Estimates the matrices A, B, C, and K of the state space model.
%   hx2abcdk        - Estimates the matrices A, B, C, D, and K of the state space model.
%   hx2abck         - Estimates the matrices A, B, C, and K of the state space model.
%   idmultisine     - Generation of a Multi Sine Signal.
%   idprbs          - Generation of a Pseudo-Random Binary Signal (PRBS).
%   lmodx           - Closed-loop LPV system identification using the PBSIDopt method.
%   lordvarx        - Closed-loop LPV system identification using the PBSIDopt method.
%   lpv2ltv         - Transforms a LPV system matrices to a LTV system matrices.
%   lx2abcdk        - Estimates the matrices A, B, C, D, and K of the state space model.
%   lx2abck         - Estimates the matrices A, B, C, and K of the state space model.
%   pec             - Prediction error cost.
%   plpv2ltv        - Transforms a PLPV system matrices to a LTV system matrices.
%   pmodx           - Closed-loop PLPV system identification using the PBSIDopt method.
%   pordvarx        - Closed-loop PLPV system identification using the PBSIDopt method.
%   predstab        - Assess stability of the predictor form of the IDAFFLPV model.
%   pschedclust     - Periodic clustering of scheduling sequence
%   px2abcdk        - Estimates the matrices A, B, C, D, and K of the state space model.
%   px2abck         - Estimates the matrices A, B, C, and K of the state space model.
%   rpbsid          - Recursive Predictor-Based Subspace Identification
%   sigscale        - Scaling of identifications signals
%   snr             - Signal to Noise Ratio (SNR)
%   spaavf          - Spectral analysis with frequency averaging.
%   vaf             - Variance Accounted For [%]
%   wmodx           - Closed-loop Wiener system identification using the PBSIDopt method.
%   wordvarx        - Closed-loop Wiener system identification using the PBSIDopt method.
%   wx2abcdk        - Estimates the matrices A, B, C, D, and K of the state space model.
%   wx2abck         - Estimates the matrices A, B, C, and K of the state space model.
