clear all;
close all;
clc

addpath Functions\CLSPA\
addpath Functions\LTIToolbox\
addpath Functions\PBSIDToolbox-0.6\

%%
% NREL5 OC4, Triple, TripleOpt, 15MW, SoftWopt, SoftW, Hexafloat (1,2,3,4,5,6,7)

load('ID_data.mat');
load('MBC_data.mat')

dt = 0.5;
bodeopts = bodeoptions;
bodeopts.FreqUnits = 'Hz';
bodeopts.MagUnits = 'abs';
bodeopts.MagScale = 'log';

V = 9 ;
St = [0.1 0.25 0.5];
D = 178.3 ;
f_e = V*St./D ;

TUcolors = [12, 35, 64 ; 
            0, 184, 200;
            0, 118, 194;
            111, 29, 119;
            239, 96, 163;
            165, 0, 52;
            224, 60, 49;
            237, 104, 66;
            255, 184, 28;
            108, 194, 74;
            0, 155, 119;
            0, 166, 214]/256;

%%

for i_for2 = 1:1:6

    [G_Surge(i_for2,:),sys_Surge(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,12))),dt,4,6) ;
    [G_Sway(i_for2,:),sys_Sway(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,13))),dt,4,6) ;
    [G_Heave(i_for2,:),sys_Heave(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,14))),dt,4,6) ;
    [G_Roll(i_for2,:),sys_Roll(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,15))),dt,4,6) ;
    [G_Pitch(i_for2,:),sys_Pitch(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,16))),dt,4,6) ;
    [G_Yaw(i_for2,:),sys_Yaw(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,17))),dt,4,6) ;
    [G_Myaw(i_for2,:),sys_Myaw(i_for2,:),~] = id_funcs(detrend(squeeze(PitchYaw(i_for2,1,:))),detrend(squeeze(MYaw(i_for2,1,:))),dt,4,6) ;
    [G_MomYaw(i_for2,:),sys_MomYaw(i_for2,:),~] = id_funcs(detrend(squeeze(MYaw(i_for2,1,:))),detrend(squeeze(Turbine1_data(i_for2,1,:,17))),dt,4,6) ;
end

hexadata = load('TurbineData_HexaFloat.mat');
hexambc = load('MBC_HexaFloat.mat');

for i_for2 = 7

    [G_Surge(i_for2,:),sys_Surge(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,12)))',dt,4,6) ;
    [G_Sway(i_for2,:),sys_Sway(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,13)))',dt,4,6) ;
    [G_Heave(i_for2,:),sys_Heave(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,14)))',dt,4,6) ;
    [G_Roll(i_for2,:),sys_Roll(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,15)))',dt,4,6) ;
    [G_Pitch(i_for2,:),sys_Pitch(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,16)))',dt,4,6) ;
    [G_Yaw(i_for2,:),sys_Yaw(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,17)))',dt,4,6) ;
    [G_Myaw(i_for2,:),sys_Myaw(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexambc.MYaw))',dt,4,6) ;
    [G_MomYaw(i_for2,:),sys_MomYaw(i_for2,:),~] = id_funcs(detrend(hexambc.PitchYaw)',detrend(squeeze(hexadata.Turbine1_data(1,:,17)))',dt,4,6) ;
end

%%

height_scale = 1.2;
width = 18.2;
height = width/height_scale;

omega = logspace(-3,0,1000)*2*pi ;
freq_plot = omega./(2*pi);

[mag_Triple_surge,phase_Triple_surge,~] = bode(G_Surge(2:3,1),omega)  ;
[mag_Triple_sway,phase_Triple_sway,~] = bode(G_Sway(2:3,1),omega)  ;
[mag_Triple_heave,phase_Triple_heave,~] = bode(G_Heave(2:3,1),omega)  ;
[mag_Triple_roll,phase_Triple_roll,~] = bode(G_Roll(2:3,1),omega)  ;
[mag_Triple_pitch,phase_Triple_pitch,~] = bode(G_Pitch(2:3,1),omega)  ;
[mag_Triple_yaw,phase_Triple_yaw,~] = bode(G_Yaw(2:3,1),omega)  ;

[mag_Soft_surge,phase_Soft_surge,~] = bode(G_Surge(5:6,1),omega)  ;
[mag_Soft_sway,phase_Soft_sway,~] = bode(G_Sway(5:6,1),omega)  ;
[mag_Soft_heave,phase_Soft_heave,~] = bode(G_Heave(5:6,1),omega)  ;
[mag_Soft_roll,phase_Soft_roll,~] = bode(G_Roll(5:6,1),omega)  ;
[mag_Soft_pitch,phase_Soft_pitch,~] = bode(G_Pitch(5:6,1),omega)  ;
[mag_Soft_yaw,phase_Soft_yaw,~] = bode(G_Yaw(5:6,1),omega)  ;

[mag_Triple_mom,phase_Triple_mom,~] = bode(G_Myaw(2:3,1),omega)  ;
[mag_Soft_mom,phase_Soft_mom,~] = bode(G_Myaw(5:6,1),omega)  ;

%% Translational Motions
fig = figure('Units', 'centimeters', 'pos', [-1 1 width height],'color','w')
subplot('Position', [0.07, 0.52, 0.44, 0.42])
loglog(freq_plot,squeeze(mag_Triple_surge(1,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5);
hold on
loglog(freq_plot,squeeze(mag_Triple_surge(2,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_sway(1,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_sway(2,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_heave(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_heave(2,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
loglog([f_e(1) f_e(1)], [1e-4 10],'k:','Linewidth',1); text(f_e(1),12.5,'$$St=0.10$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(2) f_e(2)], [1e-4 10],'k:','Linewidth',1); text(f_e(2)/1,12.5,'$$0.25$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(3) f_e(3)], [1e-4 10],'k:','Linewidth',1); text(f_e(3)*1.05,12.5,'$$0.50$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
text(5e-2,1.5e-4,'TripleSpar','Interpreter','latex','FontSize', 12,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[])
xlim([1e-3 1e-1])
ylim([1e-4 1e1])
ylabel('Gain $$\beta_{yaw}$$ to Translational Motions [m/deg]','Interpreter','latex','Fontsize',10)
leg = legend('Surge','Surge Opt.','Sway','Sway Opt.','Heave','Heave Opt.','Interpreter','latex','Fontsize',10)%,'Location','best')
leg.ItemTokenSize = [10,6]
leg.NumColumns = 3;
legend('boxoff')
pos = get(leg,'Position');
set(leg,'Position',[0.12 0.875 pos(3) pos(4)])

subplot('Position', [0.07, 0.085, 0.44, 0.42])
semilogx(freq_plot,squeeze(phase_Triple_surge(1,1,:))+360,'-','Color',TUcolors(3,:),'LineWidth',1.5)
hold on
semilogx(freq_plot,squeeze(phase_Triple_surge(2,1,:))+360,':','Color',TUcolors(3,:),'LineWidth',1.5);
semilogx(freq_plot,squeeze(phase_Triple_sway(1,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Triple_sway(2,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
semilogx(freq_plot,squeeze(phase_Triple_heave(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Triple_heave(2,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',1); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex')
xlim([1e-3 1e-1])
ylim([-360 360])
ylabel('Phase $$\beta_{yaw}$$ to Platform Motions [deg]','Interpreter','latex','Fontsize',10)
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)

subplot('Position', [0.07+0.45, 0.52, 0.44, 0.42])
loglog(freq_plot,squeeze(mag_Soft_surge(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5);
hold on
loglog(freq_plot,squeeze(mag_Soft_surge(1,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_sway(2,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_sway(1,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_heave(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_heave(1,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
loglog([f_e(1) f_e(1)], [1e-4 10],'k:','Linewidth',1); text(f_e(1),12.5,'$$St=0.10$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(2) f_e(2)], [1e-4 10],'k:','Linewidth',1); text(f_e(2)/1,12.5,'$$0.25$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(3) f_e(3)], [1e-4 10],'k:','Linewidth',1); text(f_e(3)*1.05,12.5,'$$0.50$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
text(5e-2,1.5e-4,'SoftWind','Interpreter','latex','FontSize', 12,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[],'YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([1e-4 1e1])
leg = legend('Surge','Surge Opt.','Sway','Sway Opt.','Heave','Heave Opt.','Interpreter','latex','Fontsize',10)%,'Location','best')
leg.ItemTokenSize = [10,6]
leg.NumColumns = 3;
legend('boxoff')
pos = get(leg,'Position');
set(leg,'Position',[0.57 0.875 pos(3) pos(4)])

subplot('Position', [0.07+0.45, 0.085, 0.44, 0.42])
semilogx(freq_plot,squeeze(phase_Soft_surge(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5)
hold on
semilogx(freq_plot,squeeze(phase_Soft_surge(1,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
semilogx(freq_plot,squeeze(phase_Soft_sway(2,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Soft_sway(1,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
semilogx(freq_plot,squeeze(phase_Soft_heave(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Soft_heave(1,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',1); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([-360 360])
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)
exportgraphics(gcf,'Torque2024_Figures\Bode_Plots_Translations.pdf','ContentType','vector')

%% Rotational Motions
fig = figure('Units', 'centimeters', 'pos', [-1 1 width height],'color','w')
subplot('Position', [0.07, 0.52, 0.44, 0.42])
loglog(freq_plot,squeeze(mag_Triple_roll(1,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5);
hold on
loglog(freq_plot,squeeze(mag_Triple_roll(2,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
loglog(freq_plot,medfilt1(squeeze(mag_Triple_pitch(1,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_pitch(2,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_yaw(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Triple_yaw(2,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
loglog([f_e(1) f_e(1)], [1e-4 20],'k:','Linewidth',1); text(f_e(1),25,'$$St=0.10$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(2) f_e(2)], [1e-4 20],'k:','Linewidth',1); text(f_e(2)/1,25,'$$0.25$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(3) f_e(3)], [1e-4 20],'k:','Linewidth',1); text(f_e(3)*1.05,25,'$$0.50$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
text(5e-2,1.5e-3,'TripleSpar','Interpreter','latex','FontSize', 12,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[])
xlim([1e-3 1e-1])
ylim([1e-3 2e1])
ylabel('Gain $$\beta_{yaw}$$ to ... [deg/deg]','Interpreter','latex','Fontsize',10)
leg = legend('Roll','Roll Opt.','Pitch','Pitch Opt.','Yaw','Yaw Opt.','Interpreter','latex','Fontsize',10)%,'Location','best')
leg.ItemTokenSize = [10,6]
leg.NumColumns = 3;
legend('boxoff')
pos = get(leg,'Position');
set(leg,'Position',[0.12 0.875 pos(3) pos(4)])

subplot('Position', [0.07, 0.085, 0.44, 0.42])
semilogx(freq_plot,squeeze(phase_Triple_roll(1,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5)
hold on
semilogx(freq_plot,squeeze(phase_Triple_roll(2,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
semilogx(freq_plot,medfilt1(squeeze(phase_Triple_pitch(1,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Triple_pitch(2,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
semilogx(freq_plot,squeeze(phase_Triple_yaw(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Triple_yaw(2,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',1); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex')
xlim([1e-3 1e-1])
ylim([-200 200])
ylabel('Phase $$\beta_{yaw}$$ to ... [deg]','Interpreter','latex','Fontsize',10)
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)

subplot('Position', [0.07+0.45, 0.52, 0.44, 0.42])
loglog(freq_plot,squeeze(mag_Soft_roll(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5);
hold on
loglog(freq_plot,squeeze(mag_Soft_roll(1,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
loglog(freq_plot,medfilt1(squeeze(mag_Soft_pitch(2,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_pitch(1,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_yaw(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5);
loglog(freq_plot,squeeze(mag_Soft_yaw(1,1,:)),':','Color',TUcolors(9,:),'LineWidth',1.5);
loglog([f_e(1) f_e(1)], [1e-4 20],'k:','Linewidth',1); text(f_e(1),25,'$$St=0.10$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(2) f_e(2)], [1e-4 20],'k:','Linewidth',1); text(f_e(2)/1,25,'$$0.25$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
loglog([f_e(3) f_e(3)], [1e-4 20],'k:','Linewidth',1); text(f_e(3)*1.05,25,'$$0.50$$','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
text(5e-2,1.5e-3,'SoftWind','Interpreter','latex','FontSize', 12,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[],'YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([1e-3 2e1])
leg = legend('Roll','Roll Opt.','Pitch','Pitch Opt.','Yaw','Yaw Opt.','Interpreter','latex','Fontsize',10)%,'Location','best')
leg.ItemTokenSize = [10,6]
leg.NumColumns = 3;
legend('boxoff')
pos = get(leg,'Position');
set(leg,'Position',[0.57 0.875 pos(3) pos(4)])

subplot('Position', [0.07+0.45, 0.085, 0.44, 0.42])
semilogx(freq_plot,squeeze(phase_Soft_roll(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.5)
hold on
semilogx(freq_plot,squeeze(phase_Soft_roll(1,1,:)),':','Color',TUcolors(3,:),'LineWidth',1.5);
semilogx(freq_plot,medfilt1(squeeze(phase_Soft_pitch(2,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Soft_pitch(1,1,:)),':','Color',TUcolors(6,:),'LineWidth',1.5);
semilogx(freq_plot,squeeze(phase_Soft_yaw(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.5)
semilogx(freq_plot,squeeze(phase_Soft_yaw(1,1,:))+360,':','Color',TUcolors(9,:),'LineWidth',1.5);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',1); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',1); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([-200 200])
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)
exportgraphics(gcf,'Torque2024_Figures\Bode_Plots_Rotations.pdf','ContentType','vector')

%% This creates the 4 by 2 plot shown in the paper.

height_scale = 1.8;
width = 18.2;
height = width/height_scale;

fig = figure('Units', 'centimeters', 'pos', [-1 1 width height],'color','w')
subplot('Position', [0.07, 0.48, 0.22, 0.38])
loglog(freq_plot,squeeze(mag_Triple_surge(1,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1);
hold on
loglog(freq_plot,squeeze(mag_Triple_surge(2,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_sway(1,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_sway(2,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_heave(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_heave(2,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
loglog([f_e(1) f_e(1)], [1e-4 10],'k:','Linewidth',0.85);
loglog([f_e(2) f_e(2)], [1e-4 10],'k:','Linewidth',0.85);
loglog([f_e(3) f_e(3)], [2.5e-4 10],'k:','Linewidth',0.85);
text(3.8e-2,1.5e-4,'TripleSpar','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[])
xlim([1e-3 1e-1])
ylim([1e-4 1e1])
ylabel('Gain $$\beta_{yaw}$$ to ...','Interpreter','latex','Fontsize',10)
leg = legend('Surge','Surge Opt.','Sway','Sway Opt.','Heave','Heave Opt.','Interpreter','latex','Fontsize',10);
leg.ItemTokenSize = [10,6]
leg.NumColumns = 3;
leg.Title.String = 'Translational Motions [m/deg]';
legend('boxoff')
pos = get(leg,'Position');
set(leg,'Position',[0.08 0.86 pos(3) pos(4)],'Color','white')

subplot('Position', [0.07, 0.085, 0.22, 0.38])
semilogx(freq_plot,squeeze(phase_Triple_surge(1,1,:))+360,'-','Color',TUcolors(3,:),'LineWidth',1.1)
hold on
semilogx(freq_plot,squeeze(phase_Triple_surge(2,1,:))+360,'-.','Color',TUcolors(3,:),'LineWidth',1.1);
semilogx(freq_plot,squeeze(phase_Triple_sway(1,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Triple_sway(2,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
semilogx(freq_plot,squeeze(phase_Triple_heave(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Triple_heave(2,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',0.85); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex')
xlim([1e-3 1e-1])
ylim([-360 360])
ylabel('Phase $$\beta_{yaw}$$ to ... [deg]','Interpreter','latex','Fontsize',10)
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)

subplot('Position', [0.07+0.23, 0.48, 0.22, 0.38])
loglog(freq_plot,squeeze(mag_Soft_surge(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1);
hold on
loglog(freq_plot,squeeze(mag_Soft_surge(1,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_sway(2,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_sway(1,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_heave(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_heave(1,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
loglog([f_e(1) f_e(1)], [1e-4 10],'k:','Linewidth',0.85);
loglog([f_e(2) f_e(2)], [1e-4 10],'k:','Linewidth',0.85);
loglog([f_e(3) f_e(3)], [2.5e-4 10],'k:','Linewidth',0.85);
text(3.8e-2,1.5e-4,'SoftWind','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[],'YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([1e-4 1e1])

subplot('Position', [0.07+0.23, 0.085, 0.22, 0.38])
semilogx(freq_plot,squeeze(phase_Soft_surge(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1)
hold on
semilogx(freq_plot,squeeze(phase_Soft_surge(1,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
semilogx(freq_plot,squeeze(phase_Soft_sway(2,1,:)),'-','Color',TUcolors(6,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Soft_sway(1,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
semilogx(freq_plot,squeeze(phase_Soft_heave(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Soft_heave(1,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',0.85); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([-360 360])
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)

% Rotational Motions
subplot('Position', [0.07+2*0.23+0.01, 0.48, 0.22, 0.38])
loglog(freq_plot,squeeze(mag_Triple_roll(1,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1);
hold on
loglog(freq_plot,squeeze(mag_Triple_roll(2,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
loglog(freq_plot,medfilt1(squeeze(mag_Triple_pitch(1,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_pitch(2,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_yaw(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Triple_yaw(2,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
loglog([f_e(1) f_e(1)], [1e-4 20],'k:','Linewidth',0.85);
loglog([f_e(2) f_e(2)], [1e-4 20],'k:','Linewidth',0.85);
loglog([f_e(3) f_e(3)], [2.5e-4 20],'k:','Linewidth',0.85);
text(3.8e-2,1.5e-4,'TripleSpar','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[],'YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([1e-4 1e1])
leg = legend('Roll','Roll Opt.','Pitch','Pitch Opt.','Yaw','Yaw Opt.','Interpreter','latex','Fontsize',10)
leg.ItemTokenSize = [10,6]
leg.NumColumns = 3;
leg.Title.String = 'Rotational Motions [deg/deg]';
leg.Title.FontSize = 10;
legend('boxoff')
pos = get(leg,'Position');
set(leg,'Position',[0.08+2*0.23+0.01 0.86 pos(3) pos(4)])

subplot('Position', [0.07+2*0.23+0.01, 0.085, 0.22, 0.38])
semilogx(freq_plot,squeeze(phase_Triple_roll(1,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1)
hold on
semilogx(freq_plot,squeeze(phase_Triple_roll(2,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
semilogx(freq_plot,medfilt1(squeeze(phase_Triple_pitch(1,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Triple_pitch(2,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
semilogx(freq_plot,squeeze(phase_Triple_yaw(1,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Triple_yaw(2,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',0.85); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([-360 360])
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)

subplot('Position', [0.07+3*0.23+0.01, 0.48, 0.22, 0.38])
loglog(freq_plot,squeeze(mag_Soft_roll(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1);
hold on
loglog(freq_plot,squeeze(mag_Soft_roll(1,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
loglog(freq_plot,medfilt1(squeeze(mag_Soft_pitch(2,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_pitch(1,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_yaw(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1);
loglog(freq_plot,squeeze(mag_Soft_yaw(1,1,:)),'-.','Color',TUcolors(9,:),'LineWidth',1.1);
loglog([f_e(1) f_e(1)], [1e-4 20],'k:','Linewidth',0.85);
loglog([f_e(2) f_e(2)], [1e-4 20],'k:','Linewidth',0.85);
loglog([f_e(3) f_e(3)], [2.5e-4 20],'k:','Linewidth',0.85);
text(3.8e-2,1.5e-4,'SoftWind','Interpreter','latex','FontSize', 10,'HorizontalAlignment','center')
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','XtickLabel',[],'YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([1e-4 1e1])

subplot('Position', [0.07+3*0.23+0.01, 0.085, 0.22, 0.38])
semilogx(freq_plot,squeeze(phase_Soft_roll(2,1,:)),'-','Color',TUcolors(3,:),'LineWidth',1.1)
hold on
semilogx(freq_plot,squeeze(phase_Soft_roll(1,1,:)),'-.','Color',TUcolors(3,:),'LineWidth',1.1);
semilogx(freq_plot,medfilt1(squeeze(phase_Soft_pitch(2,1,:)),10),'-','Color',TUcolors(6,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Soft_pitch(1,1,:)),'-.','Color',TUcolors(6,:),'LineWidth',1.1);
semilogx(freq_plot,squeeze(phase_Soft_yaw(2,1,:)),'-','Color',TUcolors(9,:),'LineWidth',1.1)
semilogx(freq_plot,squeeze(phase_Soft_yaw(1,1,:))+360,'-.','Color',TUcolors(9,:),'LineWidth',1.1);
semilogx([f_e(1) f_e(1)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(2) f_e(2)], [360 -360],'k:','Linewidth',0.85); 
semilogx([f_e(3) f_e(3)], [360 -360],'k:','Linewidth',0.85); 
grid on
ax = gca;
ax.FontSize = 8; 
set(gca,'TickLabelInterpreter','latex','YtickLabel',[])
xlim([1.001e-3 1e-1])
ylim([-360 360])
xlabel('Frequency [Hz]','Interpreter','latex','Fontsize',10)
exportgraphics(gcf,'Torque2024_Figures\Bode_Plots_Combined.pdf','ContentType','vector')