clear all; clc; close all

%%

load('Prescribed_Data.mat')
D = 240;
%%

TUcolors = [12, 35, 64 ; 
            0, 184, 200;
            0, 118, 194;
            111, 29, 119;
            239, 96, 163;
            165, 0, 52;
            224, 60, 49;
            237, 104, 66;
            255, 184, 28;
            108, 194, 74;
            0, 155, 119;
            0, 166, 214]/256;

height_scale = 1.5;
width = 18.2;
height = width/height_scale;

fig = figure('Units', 'centimeters', 'pos', [-1 1 width height/height_scale],'color','w');
ah = axes(fig);
d1 = plot(x./D,mean(squeeze(Velocities(1,1,:,:)),1),'Color',TUcolors(1,:),'Linewidth',1.5);
hold on
d2 = plot(x./D,mean(squeeze(Velocities(1,2,:,:)),1),'Color',TUcolors(2,:),'Linewidth',1.5);
d3 = plot(x./D,mean(squeeze(Velocities(1,3,:,:)),1),'Color',TUcolors(7,:),'Linewidth',1.5);
t1 = plot(x./D,mean(squeeze(Velocities(1,4,:,:)),1),'--','Color',TUcolors(2,:),'Linewidth',1.5);
t2 = plot(x./D,mean(squeeze(Velocities(1,5,:,:)),1),'--','Color',TUcolors(6,:),'Linewidth',1.5);
t3 = plot(x./D,mean(squeeze(Velocities(1,6,:,:)),1),'--','Color',TUcolors(9,:),'Linewidth',1.5);
t4 = plot(x./D,mean(squeeze(Velocities(1,7,:,:)),1),'--','Color',TUcolors(12,:),'Linewidth',1.5);
hold off
leg1 = legend(ah,[d1 d2 d3],'Baseline','Dynamic Yaw','Helix Bottom-Fixed','Interpreter','latex','Fontsize',10);
leg1.ItemTokenSize = [20,6];
leg1.NumColumns = 1;
leg1.Box = 'off';
pos1 = get(leg1,'Position');
set(leg1,'Position',[0.175 0.8 pos1(3) pos1(4)])

ah2 = copyobj( ah, gcf);
leg2 = legend(ah2,[t1 t2 t3 t4],'Helix $$0^{\circ}$$ Offset','Helix $$90^{\circ}$$ Offset'...
    ,'Helix $$180^{\circ}$$ Offset','Helix $$270^{\circ}$$ Offset','Interpreter','latex','Fontsize',10);
leg2.ItemTokenSize = [20,6];
leg2.NumColumns = 1;
leg2.Box = 'off';
pos2 = get(leg2,'Position');
set(leg2,'Position',[0.175 0.1 pos2(3) pos2(4)])
grid(ah2,'on')
% ax = gca;
% ax.FontSize = 10; 
set(ah2,'TickLabelInterpreter','latex')
ylabel(ah2,'Wind Speed [m/s]','Interpreter','latex','FontSize',12)
xlabel(ah2,'Distance [D]','Interpreter','latex','FontSize',12)
xlim([-1 6])


%exportgraphics(gcf,'Prescribed_Motion.pdf','ContentType','vector')
% 
% leg1 = legend('Baseline','Dynamic Yaw','Helix Bottom-Fixed','Helix $$0^{\circ}$$ Offset','Helix $$90^{\circ}$$ Offset'...
%     ,'Helix $$180^{\circ}$$ Offset','Helix $$270^{\circ}$$ Offset','Interpreter','latex','Fontsize',10);
% leg1.ItemTokenSize = [20,6];
% leg1.NumColumns = 1;
% legend('boxoff')
% pos = get(leg1,'Position');
% set(leg1,'Position',[0.175 0.8 pos(3) pos(4)])